'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _preact = require('preact');

var _esnext = require('skatejs/esnext');

var _esnext2 = require('@skatejs/renderer-preact/esnext');

var _esnext3 = _interopRequireDefault(_esnext2);

var _index = require('./index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const withComponent = Base => (0, _esnext.withProps)((0, _esnext.withRenderer)((0, _esnext.withUnique)(Base || HTMLElement)));
const SkateComponent = withComponent((0, _esnext3.default)());

function propsWithDefault(type, def) {
  return _extends({}, type, { default: def });
}

class PieWrap extends SkateComponent {
  attachShadow() {
    return this;
  }

  renderCallback({ props }) {
    return (0, _preact.h)(_index.Pie, props);
  }
}

PieWrap.props = {
  legend: _esnext.props.any,
  type: propsWithDefault(_esnext.props.string, 'doughnut'),
  height: propsWithDefault(_esnext.props.number, 150),
  width: propsWithDefault(_esnext.props.number, 300),
  redraw: _esnext.props.boolean,
  options: _esnext.props.object,
  datasetKeyProvider: _esnext.props.any,
  data: _esnext.props.object
};
customElements.define('pie-chart', PieWrap);